<?php
/*
 Plugin Name: svupdate-caller
 Plugin URI: http://dougal.gunters.org/
 Author: Dougal Campbell
 Author URI: http://dougal.gunters.org/
 Description: Call out to the external svupdate utility to manage IPFW firewall rules when spam is encountered.
 Version: 1.0
*/

// Location of the ipupdate script:
$ipupdate = '/usr/local/bin/ipupdate';

// The comment_post action requires that you set 
// the 'accepted_args' param to 2.
add_action('comment_post','add_spammer',10,2);


// Like stristr(), except $needle is an array.
// Returns true if any matches found, false if no matches
if(!function_exists('stristr_a')) {
function stristr_a($haystack, $needles) {
	// make sure it's a list
	if (count($needles)) {
		// Check each needle against the haystack string
		foreach ($needles as $needle) {
			// skip blank lines
			$needle = trim($needle);
			if (empty($needle)) continue; 

			if (stristr($haystack, $needle))
				return true;
		}
	}

	// No matches found.
	return false;

} // stristr_a()
}

if (! strstr($_SERVER['REQUEST_URI'], '/wp-admin/')) {
	// All blacklist keys will be checked against the referer
	$blacklist_keys = get_settings('blacklist_keys');
	$spam_referers = explode("\n",$blacklist_keys);

	
	// Nuke spam referers. Don't bother doing the other normal spam checks.
	if (stristr_a($_SERVER['HTTP_REFERER'],$spam_referers)) {
		add_spammer(0,'spam');
	}


	// All 'pinappleproxy' connections will be nuked.
	if (stristr($_SERVER['HTTP_VIA'],'pinappleproxy')) {
		add_spammer(0,'spam');
	}

} // if(wp-admin)

// If the comment status was 'spam', return an error to the client.
// Perhaps some spam bots will be smart enough to stop trying after
// they get errors.
function add_spammer($cid, $status) {
	if ($status == 'spam') {
		$ip_address = escapeshellarg($_SERVER['REMOTE_ADDR']);
		exec("$ipupdate $ip_address");

	} // if(spam)

} // add_spammer()

?>